﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*RegExp demo by ts-soft.
;*Demonstrates using the VBScript.RegExp object to provide support for regular expressions.
;//////////////////////////////////////////////////////////////////////////////////////////

IncludePath "..\"
XIncludeFile "COMatePLUS.pbi"


EnableExplicit 


;*Executes a regular expression And prints out matches.
Procedure RegExp(szPattern.s, szString.s, bIgnoreCase.l = #True)
  Protected regExObject.COMateObject
  Protected regEnum.COMateEnumObject
  Protected regMatch.COMateObject
  Protected match.l, nFirstIndex.l, nLength.l, szValue.s
  regExObject = COMate_CreateObject("VBScript.RegExp")
  If regExObject
    regExObject\SetProperty("Pattern = '" + szPattern + "'")
    regExObject\SetProperty("IgnoreCase = " + Str(bIgnoreCase) + " AS BOOLEAN")  ;The boolean type modifier is required because we are not embedding a #True or #False value directly.
    regExObject\SetProperty("Global = #True") ;No boolean type modifier required here.
    ;We now create a COMateEnum object to enumerate the results of applying the regular expression etc.
      regEnum = regExObject\CreateEnumeration("Execute('" + szString + "')")
    If regEnum
      regMatch = regEnum\GetNextObject()
      While regMatch
        nFirstIndex = 0 : nLength = 0 : szValue = ""
        nFirstIndex = regMatch\GetIntegerProperty("FirstIndex")
        nLength = regMatch\GetIntegerProperty("Length")
        szValue = regMatch\GetStringProperty("Value")
        If szValue
          Debug "Match found at characters " + Str(nFirstIndex) + " to " + Str(nFirstIndex + nLength-1) + " Match value is " + szValue
        EndIf
        regMatch\Release()
        regMatch = regEnum\GetNextObject()
      Wend
      regEnum\Release()
    EndIf
  regExObject\Release()
  EndIf
EndProcedure


;*Replace:
Procedure Replace(szPattern.s, szString.s, szReplacement.s, bIgnoreCase.l = #True)
  Protected regExObject.COMateObject, szResult.s
  regExObject = COMate_CreateObject("VBScript.RegExp")
  If regExObject
    regExObject\SetProperty("Pattern = '" + szPattern + "'")
    regExObject\SetProperty("IgnoreCase = " + Str(bIgnoreCase) + " AS BOOLEAN")  ;The boolean type modifier is required because we are not embedding a #True or #False value directly.
    regExObject\SetProperty("Global = #True") ;No boolean type modifier required here.
    szResult = regExObject\GetStringProperty("Replace('"+szString+"', '" + szReplacement + "')")
    If szResult
      Debug szResult
    EndIf
    regExObject\Release()
  EndIf
EndProcedure


Debug "Running regular expression find sample..."
Debug "------------------------------------------"
RegExp("is.", "IS1 is2 IS3 is4", #True)

Debug ""
Debug "Running regular expression replace sample..."
Debug "------------------------------------------"
Replace("fox", "The quick brown fox jumped over the lazy dog.", "cat", #True)

; IDE Options = PureBasic 4.30 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 67
; FirstLine = 29
; Folding = -
; EnableUnicode
; EnableThread
; Executable = nxReportU.dll