﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*WMI demo - services.
;/////////////////////////////////////////////////////////////////////////////////

IncludePath "..\..\"
XIncludeFile "COMatePLUS.pbi"

Enumeration
  #StopService
  #PauseService
  #StartService
EndEnumeration


;Returns #True if successful.
Procedure Set_Service(serviceName$, action = #StopService)
  Protected result, strComputer.s, objWMIService.COMateObject, service.COMateObject 
  Protected colServices.COMateEnumObject 
  strComputer = "." 
  objWMIService = COMate_GetObject("winmgmts:\\" + strComputer + "\root\cimv2", "") 
  If objWMIService 
    colServices = objWMIService\CreateEnumeration("ExecQuery('Select * FROM Win32_Service WHERE Name = $0027" + serviceName$ + "$0027')") 
    If colServices
      service = colServices\GetNextObject() 
      If service
        Select action
          Case #StopService
            If SUCCEEDED(service\Invoke("StopService"))
              result = #True
            EndIf
          Case #PauseService
            If SUCCEEDED(service\Invoke("PauseService"))
              result = #True
            EndIf
          Case #StartService
            If SUCCEEDED(service\Invoke("StartService"))
              result = #True
            EndIf
        EndSelect
        service\Release() 
      EndIf 
      colServices\Release() 
    EndIf 
    objWMIService\Release()  
  EndIf 
  ProcedureReturn result
EndProcedure 

Debug Set_Service("Apache2", #StopService)
; IDE Options = PureBasic 4.30 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 9
; Folding = -
; EnableUnicode
; EnableThread
; Executable = nxReportU.dll