﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*AnimatedGif demo - AnimatedGif.ocx, by Kiffi
;* http://www.freevbcode.com/ShowCode.asp?id=4045
;/////////////////////////////////////////////////////////////////////////////////

IncludePath "..\..\"
XIncludeFile "COMatePLUS.pbi"
DisableExplicit

Enumeration
  #Load
  #Unload
  #Stop
  #Restart
  #NextFrame
  #GIF
EndEnumeration

GifObject.COMateObject
If OpenWindow(0, #PB_Ignore, #PB_Ignore, 300, 300, "COMate-AnimatedGIF demo", #PB_Window_SystemMenu|#PB_Window_Invisible)
   
  ButtonGadget(#Load, 5, 5, 70, 25, "Load...")
  ButtonGadget(#Unload, 5, 35, 70, 25, "Unload")
  ButtonGadget(#Stop, 5, 65, 70, 25, "Stop")
  ButtonGadget(#Restart, 5, 125, 70, 25, "Restart")
  ButtonGadget(#NextFrame, 5, 95, 70, 25, "Next frame")

  GifObject = COMate_CreateActiveXControl(80, 5, 215, 290, "AnimatedGif.AniGif")

  If GifObject = 0
    If COMate_RegisterCOMServer("AnimatedGif.ocx") = #S_OK
      blnRegister = #True
      GifObject = COMate_CreateActiveXControl(80, 5, 215, 290, "AnimatedGif.AniGif")
    EndIf
  EndIf

  If GifObject
    HideWindow(0, 0)
    GifObject\Invoke("LoadFile('computer16.gif', #False)")
    Repeat
      Select WaitWindowEvent()
        Case #PB_Event_Gadget
          Select EventGadget()
            Case #Load
              myFile$=OpenFileRequester("Please select", "", "GIF files (*.gif)|*.gif", 1)
              If myFile$
                GifObject\Invoke("LoadFile('" + myFile$ + "', #False)")
              EndIf
            Case #Unload
              GifObject\Invoke("LoadFile(#nullstring, #False)")
            Case #Stop
              GifObject\Invoke("StopAnimate(#True, #True)")
            Case #Restart
              GifObject\Invoke("RestartAnimate")
            Case #NextFrame
              GifObject\Invoke("NextFrame")
          EndSelect
        Case #PB_Event_CloseWindow
          Break
      EndSelect
    ForEver
    GifObject\Release()
  EndIf    
  CloseWindow(0)

  If blnRegister
    COMate_UnRegisterCOMServer("AnimatedGif.ocx")
  EndIf
EndIf

If GifObject = 0
    MessageRequester("COMate -AnimatedGif demo", "Couldn't create the ActiveX control!")
EndIf

; IDE Options = PureBasic 4.60 Beta 1 (Windows - x86)
; CursorPosition = 11
; EnableUnicode
; EnableXP
; Executable = test.exe