﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*Collection enumeration demo.
;/////////////////////////////////////////////////////////////////////////////////

IncludePath "..\"
XIncludeFile "COMatePLUS.pbi"
DisableExplicit

XML$ = "<addresses>"
XML$ + " <address>"
XML$ + "  <forename>Peter</forename>"
XML$ + "  <surname>Parker</surname>"
XML$ + " </address>"
XML$ + " <address>"
XML$ + "  <forename>Bruce</forename>"
XML$ + "  <surname>Wayne</surname>"
XML$ + " </address>"
XML$ + " <address>"
XML$ + "  <forename>Clark</forename>"
XML$ + "  <surname>Kent</surname>"
XML$ + " </address>"
XML$ + "</addresses>"

;Declare COMate objects.
  Define.COMateObject DomObject, NodeObject

;Declare COMateEnum objects.
  Define.COMateEnumObject DomENUMObject


DomObject = COMate_CreateObject("MSXML.DOMDocument")

If DomObject

  DomObject\Invoke("LoadXml('" + XML$ + "')")
  ;Begin enumeration.
    DomENUMObject = DomObject\CreateEnumeration("SelectNodes('addresses/address')")
    If DomENUMObject
      NodeObject = DomENUMObject\GetNextObject()
      While NodeObject
        text$ = NodeObject\GetStringProperty("Xml")
        If text$
          MessageRequester("COMate -Collection enumeration demo", text$)
        EndIf
        NodeObject\Release()
        NodeObject = DomENUMObject\GetNextObject()
      Wend
      DomENUMObject\Release()
    EndIf
  DomObject\Release()
Else
  MessageRequester("COMate -Collection enumeration demo", "Couldn't create the application object!")
EndIf



; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 58
; FirstLine = 27
; EnableUnicode
; EnableThread
; Executable = nxReportU.dll