﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*Excel demo.
;/////////////////////////////////////////////////////////////////////////////////

IncludePath "..\"
XIncludeFile "COMatePLUS.pbi"
DisableExplicit


date$ = FormatDate("%dd/%mm/%yyyy", Date())

Define.COMateObject ExcelObject, WorkBook
ExcelObject = COMate_CreateObject("Excel.Application")

If ExcelObject
  If ExcelObject\SetProperty("Visible = #True") = #S_OK
    WorkBook = ExcelObject\GetObjectProperty("Workbooks\Add")
    If WorkBook
      ExcelObject\SetProperty("Cells(1,1) = 'Hello'")
      ExcelObject\SetProperty("Cells(1,2) = 'from'")
      ExcelObject\SetProperty("Cells(1,3) = 'COMate!'")
      ExcelObject\SetProperty("Cells(1,5) = 'Today$0027s date is'")  ;$0027 is a hex escape code used to insert a ' (ascii 39) character.
      ExcelObject\SetProperty("Cells(1,6) = '" + date$ + "' AS DATE")
      ExcelObject\SetProperty("Cells(4,1) = 6.25")
      ;Retrieve a double value and a date.
        dbl.d = ExcelObject\GetRealProperty("Cells(4,1)")
          MessageRequester("COMate - Excel demo", "Result Cells(4,1) : " + StrD(dbl))
      ;For the date we retrieve it in string format.
        newDate$ = ExcelObject\GetStringProperty("Cells(1,6)")
          MessageRequester("COMate - Excel demo", "Result Cells(1,6) : " + newDate$)
      ExcelObject\Invoke("Quit()") 
      WorkBook\Release()
    EndIf
  EndIf
  ExcelObject\Release()
Else
  MessageRequester("COMate -Excel demo", "Couldn't create the application object!")
EndIf

; IDE Options = PureBasic 5.42 Beta 2 LTS (Windows - x64)
; ExecutableFormat = Shared Dll
; CursorPosition = 32
; FirstLine = 9
; EnableUnicode
; Executable = nxReportU.dll