﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*Retrieve text from a Word document using COMate_GetObject().
;/////////////////////////////////////////////////////////////////////////////////

MyWordDoc$ = "c:\Story\Notes.doc"

IncludePath "..\"
XIncludeFile "COMatePLUS.pbi"


Define.COMateObject WordDocObject

;Using COMate_GetObject() allows us to obtain a Word document object directly.
;The alternative is to use COMate_CreateObject("Word.Application") and then use the "Documents\Open" object\method etc.
;In the following method call you can replace "Word.Document" by an empty string in this case as the MyWordDoc$ file is
;enough for COM to locate the correct object file.
  WordDocObject = COMate_GetObject(MyWordDoc$, "Word.Document")

If WordDocObject
  text$ = WordDocObject\GetStringProperty("Range\Text")
  WordDocObject\Release()
  MessageRequester("COMate -Get text from word document!", text$)  ;Would be better off placing this text in an Editor gadget.
Else
  MessageRequester("COMate -Get text from word document!", "Couldn't create the document object!")
EndIf

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 22
; EnableUnicode
; EnableThread
; Executable = nxReportU.dll